<?php

	class VolumeDiscount {
		var $connection;
		var $kartRecordset;
		var $table;
		var $levelColumn;
		var $discountColumn;
		var $isProcent;
		var $oldPrice;
		var $kartObject;

		/**
			constructor
		*/
		function VolumeDiscount($oldPrice) {
			$this->oldPrice = $oldPrice;
			$this->kartObject = krt_getKartRecordsetNoMove();
		}

		/**
			set The Conection Object
			@params
				$connection - ADODB Connection reference
			@return
			none
		*/
		function setConnection(&$conn) {
			$this->connection = &$conn;
		}
		
		/**
			set the Discount Table
			@param
				$table - discount table
			@return
				none
		*/
		function setTable($table) {
			$this->table = $table;
		}

		/**
			set the discount column
			@params
				$discountColumn -
			@retuns
			none
		*/
		function setDiscountColumn($discountColumn) {
			$this->discountColumn = $discountColumn;
		}

		/**
			set the level column
			@params
				$levelColumn -
			@retuns
			none
		*/
		function setLevelColumn($levelColumn) {
			$this->levelColumn = $levelColumn;
		}
		
		/**
			set if the discount is procentual or absolut
		*/
		function isProcent($isProcent = 0) {
			$this->isProcent = $isProcent;
		}
		
		/**
			apply the level discount
			levels are lower limited, this means the greater level that is smaller(or equal) that the price will be applied
			@params
				$uidVal
			@return
				new price
		*/
		function applyDiscount($uidVal) {
			$total = 0;
			$noprd = 0;
			$kartObj = $this->kartObject;
			for ($idx = 0;$idx < $kartObj->nRows;$idx++) {
				$oPrice = $kartObj->fields[$idx]['priceColWoVol'] + @$kartObj->fields[$idx][$kartObj->origPricePropsCol];
				$quantity = $kartObj->fields[$idx][$kartObj->quantityCol];
				$noprd += $quantity;
				$total += $oPrice * $quantity;
			}
			
			//$total = $this->kartObject->getTotalPrice();// + $this->oldPrice;
			
			$tmSQL = 'select ' . $this->discountColumn . ' from ' . $this->table . ' where ' . $this->levelColumn . 
			' <= ' . $total . ' order by ' . $this->levelColumn . ' DESC';
			
			$rs = $this->connection->Execute($tmSQL) or die($this->connection->ErrorMsg());
					
			$discount = ($rs->Fields($this->discountColumn) ? $rs->Fields($this->discountColumn) :0);
			if ($this->isProcent) {
				return $this->oldPrice - ($discount / 100) * $this->oldPrice;
			} else {
				return $this->oldPrice - $discount/($noprd==0?1:$noprd);
			}
		}

	}

?>