<?php

class AddToKartRegister 
{
	var $sessionId;
	var $fields = array();
	var $urlParamName = 'MXKsessionId';
	var $isDiscounted;
	
	/**
		Constructor
		initialize sessionId random identification number
	*/
	function AddToKartRegister() {
		$this->sessionId = 'ADDTOKART' . uniqid("");
		$this->isDiscounted = true;
	}
	
	/**
		register a new field to be passed by session
		@params
			$fieldName - string - the name of the field to be registered in session
			$fieldValue - mized - value of the field to be registered in session
		@return
			- none
	*/
	function registerField($fieldName,$fieldValue) {
		$this->fields[$fieldName] = $fieldValue;
	}
	
	
	/**
		specify if we apply the discounts on products
	*/
	function setIsDiscounted($isDiscounted) {
		$this->isDiscounted = $isDiscounted;
	}
	
	/**
		register the fields in session and add the MXKsessionId parameter to the given url
		@params
			$url - url where the insert to kart login is found
		@return
			string - url with MXKsessionId parameter
	*/
	function getAddToKartLink($url) {
		if ($this->isDiscounted) {
				$kartRs = &krt_getKartRecordsetNoMove();
				$this->fields[$kartRs->origPriceCol] = $this->fields[$kartRs->priceCol];
				$this->fields[$kartRs->priceCol] = $kartRs->getFPPrice($this->fields[$kartRs->priceCol],$this->fields[$kartRs->unique]);
		}
		$_SESSION[$this->sessionId] = $this->fields;
		return KT_addReplaceParam($url,$this->urlParamName,$this->sessionId);
	}
	
}
?>