<?php
	// checkout class for custom pg
	class krt_checkoutPgpemail extends krt_checkoutAbstract {

		// this method is called on the checkout page.
		// It will redirect the user to the payment gateway
		function redirectToPaymentGateway($msg) {
			$kartProps = $GLOBALS['kartProps'];	

			// get the order details from the database
			$sql = "select * from ".$kartProps['Korders']['orders']['tableName']." where ".$kartProps['Korders']['orders']['pk']."='" . $this->kartRs->getOrderID() . "'";
			$rs = $this->connection->Execute($sql) or die($this->connection->ErrorMsg());
			echo '<div style="display:hidden">'."\n";
			// write the form that will redirect the user to the Payment Gateway Site
			echo '<FORM METHOD="POST" ACTION="https://' . $_SERVER["HTTP_HOST"];
			echo preg_replace("#/[^/]*$#", '/', $_SERVER["PHP_SELF"]);
			echo 'pgpemail.php">'."\n";

			// we should send the currency code (eur, usd, etc)
			echo '	<input type="hidden" name="currency_code" value="' . krt_getCurrentCurrency() . '">'."\n";

			// we should send the amount to be paid
			// ACO - make sure to specify the limits depending on the PG availability
			echo '	<input type="hidden" name="amount" value="';
			echo number_format(krt_transformPrice($rs->Fields($kartProps['Korders']['orders']['amount']), krt_getCurrentCurrency()), 2, '.', '');
			echo '">'."\n";

			// we should send the billing details that we have collected to the payment gateway
			echo ' <INPUT TYPE="HIDDEN" NAME="first_name" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['firstname'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="last_name" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['lastname'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="address" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['streetaddress'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="city" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['city'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="state" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['state'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="zip" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['zip'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="country" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['country'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="phone" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['phone'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="email" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['email'])) . '">'."\n";

			// we should send the Kart ID in a variable to be returned from the payment gateway
			// ACO - this depends from PG to PG - paypal - custom, etc
			echo ' <input type="hidden" name="myParam" value="';
			echo $this->kartRs->getOrderID();
			echo '">'."\n";

			// we should send the return URL to the payment gateway. This is where the user will be re-directed after the payment
			echo ' <INPUT TYPE="HIDDEN" NAME="returnUrl" VALUE="';
			echo 'http';
			if (isset($_SERVER['HTTPS']) && ($_SERVER['HTTPS'] == "on")) {
				echo 's';
			}
			echo '://' . $_SERVER["HTTP_HOST"];
			echo preg_replace("#/[^/]*/[^/]*?$#", '/' . $this->params['returnUrl'], $_SERVER["PHP_SELF"]);
			echo '"> '."\n";

			echo ' <INPUT TYPE="SUBMIT"> '."\n";
			echo '</FORM>'."\n";
			echo '</div>'."\n";
			if ($msg) {
				echo $msg . "\n";
			}
			// we now automatically submit the form
			echo '<script>'."\n";
			echo 'document.forms[0].submit();'."\n";
			echo '</script>'."\n";
		}

		// this function is called from the return page.
		// It will verify if the payment was successfull and also avoid URL Attacks
		function verifyPayment(&$tNG) {
			$kartProps = $GLOBALS['kartProps'];

			// re-calculate the amount as we keep it in USD in the database
			// ACO - if the actual payment was made in other currency - ERROR
			$amount = '-1';
			$sql = "select ".$kartProps['Korders']['orders']['amount']." as amount, ".$kartProps['Korders']['orders']['details']." as details from ".$kartProps['Korders']['orders']['tableName']." where ".$kartProps['Korders']['orders']['pk']."='" . addslashes(stripslashes(@$_POST['orderID'])) . "'";
			$rs = $this->connection->Execute($sql) or die($this->connection->ErrorMsg());
			if ($rs && $rs->RecordCount() == 1) {
				$amount = number_format(krt_transformPrice($rs->Fields('amount'), @$_POST['currency_code']), 2, '.', '');
			}

			// check the response code form the server
			if (@$_POST['response_code'] != 'success') {
				//if 'success', then we set the order as succesfull (payed)
				$tNG->addColumn($kartProps['Korders']['orders']['status'], 'STRING_TYPE', 'VALUE', 'Failed');
				$tNG->addColumn($kartProps['Korders']['orders']['details'], 'STRING_TYPE', 'VALUE', addslashes($rs->Fields('details')) . date('Y-m-d H:i:s') . " Failed: ".@$_POST['response_reason_text']."<br>\n");
			} else {
				// if not, we set the order as 'failed'
				$tNG->addColumn($kartProps['Korders']['orders']['status'], 'STRING_TYPE', 'VALUE', 'Confirmed');
				$tNG->addColumn($kartProps['Korders']['orders']['details'], 'STRING_TYPE', 'VALUE', addslashes($rs->Fields('details')) . date('Y-m-d H:i:s') . " Waiting For Processing: ".@$_POST['response_reason_text']."<br>\n");
			}
		}

		// this function is called from the return url after the payment is verified (see verifyPayment() function above)
		// here we add aditional fields to the current transaction
		function processPayment(&$tNG) {
			$kartProps = $GLOBALS['kartProps'];
			// list of post variables with corresponding fields from the orders table
			$vars = array(
				'orderID' => $kartProps['Korders']['orders']['ordernumber'],
			);
			foreach($vars as $key=>$val){
				if (isset($_POST[$key])) {
					// if the payment gateway sent us this parameter, we will save it in the database
					$tNG->addColumn($val, 'STRING_TYPE', 'VALUE', trim((@$_POST[$key])));
				}
			}
		}
	}

	// each payment gateway has different parameter names for custom variables.
	// Here we unify them in one single, called 'orderID'.
	// For this specific case, the parameter name is myParam, but it could be called differently from one Payment Gateway to another.
	// For differences, please see other payment gateways implementatoions.
	if (isset($_POST['myParam'])) {
		$_POST['orderID'] = $_POST['myParam'];
	}

?>
