<?php
	// checkout class for custom pg
	class krt_checkoutWorldpay extends krt_checkoutAbstract {

		// this method is called on the checkout page.
		// It will redirect the user to the payment gateway
		function redirectToPaymentGateway($msg) {
			$kartProps = $GLOBALS['kartProps'];

			// get the order details from the database
			$sql = "select * from ".$kartProps['Korders']['orders']['tableName']." where ".$kartProps['Korders']['orders']['pk']."='" . $this->kartRs->getOrderID() . "'";
			$rs = $this->connection->Execute($sql) or die($this->connection->ErrorMsg());
			echo '<div style="display:hidden">'."\n";
			// write the form that will redirect the user to the Payment Gateway Site
			echo '<FORM METHOD="POST" ACTION="https://select.worldpay.com/wcc/purchase">'."\n";

			// we should send the merchant ID
			echo ' <INPUT TYPE="HIDDEN" NAME="instId" VALUE="';
			echo $this->params['instId'];
			echo '">'."\n";

			// we should send the currency code (eur, usd, etc)
			$currency = krt_getCurrentCurrency();
			echo '	<input type="hidden" name="currency" value="' . $currency . '">'."\n";


			// we should send the amount to be paid
			// ACO - make sure to specify the limits depending on the PG availability
			echo '	<input type="hidden" name="cost" value="';
			$amount = number_format(krt_transformPrice($rs->Fields($kartProps['Korders']['orders']['amount']), krt_getCurrentCurrency()), 2, '.', '');
			echo $amount;
			echo '">'."\n";

			echo '<input type="hidden" name="signatureFields" value="amount:currency:cartId">' . "\n";
			$signature = $this->params['MD5Secret'] . ":$amount:$currency:" . $this->kartRs->getOrderID();
			$signature = md5($signature);
			echo '<input type="hidden" name="signature" value="' . $signature . '">' . "\n";


			// we should send the billing details that we have collected to the payment gateway
			echo ' <INPUT TYPE="HIDDEN" NAME="name" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['firstname'])) . " " . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['lastname'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="email" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['email'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="tel" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['phone'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="address" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['streetaddress'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="postcode" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['zip'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="country" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['country'])) . '">'."\n";

			echo ' <INPUT TYPE="HIDDEN" NAME="city" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['city'])) . '">'."\n";
			echo ' <INPUT TYPE="HIDDEN" NAME="state" VALUE="' . htmlspecialchars($rs->Fields($kartProps['Korders']['orders']['state'])) . '">'."\n";
			
			if (isset($GLOBALS['KT_paymentTest']) && $GLOBALS['KT_paymentTest']) {
				echo ' <INPUT TYPE="HIDDEN" NAME="testMode" VALUE="100">'."\n";				
			}
			//echo ' <INPUT TYPE="HIDDEN" NAME="MC_callback" VALUE="';
			//echo 'http';
			//if (isset($_SERVER['HTTPS']) && ($_SERVER['HTTPS'] == "on")) {
			//	echo 's';
			//}
			//echo '://' . $_SERVER["HTTP_HOST"];
			//echo $_SERVER["HTTP_HOST"];
			//echo preg_replace("#/[^/]*/[^/]*?$#", '/' . $this->params['returnUrl'], $_SERVER["PHP_SELF"]);
			//echo '"> '."\n";


			// we should send the Kart ID in a variable to be returned from the payment gateway
			// ACO - this depends from PG to PG - paypal - custom, etc
			echo ' <input type="hidden" name="cartId" value="';
			echo $this->kartRs->getOrderID();
			echo '">'."\n";

			echo ' <INPUT TYPE="SUBMIT"> '."\n";
			echo '</FORM>'."\n";
			echo '</div>'."\n";
			if ($msg) {
				echo $msg . "\n";
			}
			// we now automatically submit the form
			echo '<script>'."\n";
			echo 'document.forms[0].submit();'."\n";
			echo '</script>'."\n";
		}

		// this function is called from the return page.
		// It will verify if the payment was successfull and also avoid URL Attacks
		function verifyPayment(&$tNG) {
			$kartProps = $GLOBALS['kartProps'];

			// re-calculate the amount as we keep it in USD in the database
			// ACO - if the actual payment was made in other currency - ERROR
			$amount = '-1';
			$sql = "select ".$kartProps['Korders']['orders']['amount']." as amount, ".$kartProps['Korders']['orders']['details']." as details from ".$kartProps['Korders']['orders']['tableName']." where ".$kartProps['Korders']['orders']['pk']."='" . addslashes(stripslashes(@$_POST['orderID'])) . "'";
			$rs = $this->connection->Execute($sql) or die($this->connection->ErrorMsg());
			if ($rs && $rs->RecordCount()== 1) {
				$amount = number_format(krt_transformPrice($rs->Fields('amount'), @$_POST['currency']), 2, '.', '');
			}

			// if the digest that the payment gateway sent is different than the one we compile, then we have an URL attack
			if ($kartProps['payment']['properties']['callbackPW'] != @$_POST['callbackPW']) {
				$tNG->addColumn($kartProps['Korders']['orders']['status'], 'STRING_TYPE', 'VALUE', 'URL Attack');
				$tNG->addColumn($kartProps['Korders']['orders']['details'], 'STRING_TYPE', 'VALUE', $rs->Fields('details') . date('Y-m-d H:i:s') . " Error: Callback Pasword do not match<br>\n");
			} else {
				// test testMode
				if (isset($_POST['testMode']) && ($_POST['testMode']==100 || $_POST['testMode']==101)) {
					$tNG->addColumn($kartProps['Korders']['orders']['status'], 'STRING_TYPE', 'VALUE', '<span style="color:red; font-weight: bold;">This Transaction is in test Mode</span>');
					$tNG->addColumn($kartProps['Korders']['orders']['details'], 'STRING_TYPE', 'VALUE', $rs->Fields('details') . date('Y-m-d H:i:s') . " Error: Test Mode Attack<br>\n");
				} else {
					// check the response code form the server
					if (@$_POST['transStatus'] != 'Y') {
						//if 'success', then we set the order as succesfull (payed)
						$tNG->addColumn($kartProps['Korders']['orders']['status'], 'STRING_TYPE', 'VALUE', 'Failed');
						$tNG->addColumn($kartProps['Korders']['orders']['details'], 'STRING_TYPE', 'VALUE', addslashes($rs->Fields('details')) . date('Y-m-d H:i:s') . " Failed: ".@$_POST['rawAuthMessage']."<br>\n");
					} else {
						// if not, we set the order as 'failed'
						$tNG->addColumn($kartProps['Korders']['orders']['status'], 'STRING_TYPE', 'VALUE', 'Confirmed');
						$tNG->addColumn($kartProps['Korders']['orders']['details'], 'STRING_TYPE', 'VALUE', addslashes($rs->Fields('details')) . date('Y-m-d H:i:s') . " Completed: ".@$_POST['x_response_reason_text']."<br>\n");
					}
				}
			}
		}

		// this function is called from the return url after the payment is verified (see verifyPayment() function above)
		// here we add aditional fields to the current transaction
		function processPayment(&$tNG) {
			$kartProps = $GLOBALS['kartProps'];
			// list of post variables with corresponding fields from the orders table
			$vars = array(
				'transId' => $kartProps['Korders']['orders']['ordernumber'],
			);
			foreach($vars as $key=>$val){
				if (isset($_POST[$key])) {
					// if the payment gateway sent us this parameter, we will save it in the database
					$tNG->addColumn($val, 'STRING_TYPE', 'VALUE', trim((@$_POST[$key])));
				}
			}
		}
	}

	// each payment gateway has different parameter names for custom variables.
	// Here we unify them in one single, called 'orderID'.
	// For this specific case, the parameter name is myParam, but it could be called differently from one Payment Gateway to another.
	// For differences, please see other payment gateways implementatoions.
	if (isset($_POST['cartId'])) {
		$_POST['orderID'] = $_POST['cartId'];
	}

?>
