<?php
/**
	get the kart Recordset stored in session
	@return
	Object - the Kart Recordset
*/
function &krt_getKartRecordset() 
{
	krt_getKartRecordsetNoMove();
	$_SESSION['KT_MXKART']->MoveFirst();
	return $_SESSION['KT_MXKART'];
}

/**
	get the kart Recordset stored in session
	does not perform MoveFirst action
	@return
	Object - the Kart Recordset
*/
function &krt_getKartRecordsetNoMove() 
{
	if (isset($GLOBALS['kartUpdated'])) {
		$kartUpdated = $GLOBALS['kartUpdated'];
	}
	
	//print_r($_SESSION['KT_MXKART']);
	if (!isset($_SESSION['KT_MXKART'])) {
		$mxKart = new krt_mxKart();
		$_SESSION['KT_MXKART'] = $mxKart;
	} 
	$_SESSION['KT_MXKART']->loadProps();
	if (!isset($kartUpdated) && $_SESSION['KT_MXKART']->nRows > 0) {
		$GLOBALS['kartUpdated'] = true;
		$tmp = $_SESSION['KT_MXKART']->getFPPrice($_SESSION['KT_MXKART']->fields[0]['origPrice'],$_SESSION['KT_MXKART']->fields[0]['id']) + @$_SESSION['KT_MXKART']->fields[0]['origPriceProps'];
		if ($tmp != $_SESSION['KT_MXKART']->fields[0]['price']) {
			$_SESSION['KT_MXKART']->UpdateKart();
		}
	}
	return $_SESSION['KT_MXKART'];
}

/**
	apply the Fp discount functions to a custom price
	@param
		$price - price
	@return
		the discounted price
*/
function krt_getFpDiscount($price,$uniqueKeyVal) 
{
	$kartRs = &krt_getKartRecordsetNoMove();
	return krt_showPrice($kartRs->getFPPrice($price,$uniqueKeyVal));
}

/**
	check for discounts for a gived product
	@params
		$productId
	@return
		true/false
*/
function krt_checkDiscount($price,$productId) 
{
	$kartRs = &krt_getKartRecordsetNoMove();
	$discP = $kartRs->getFPPrice($price,$productId);
	if ($discP != $price) {
		return true;
	} else {
		return false;
	}
}

/**
	destroy the kart from the PHP session
	@param
		none
	@return
		none
*/
function krt_destroyKart() 
{
	session_unregister('KT_MXKART');
}

/**
	remove all AddToKart session entries
*/
function krt_cleanAddToKartSession() 
{
	if (is_array($_SESSION)){
		foreach($_SESSION as $key=>$value) {
			if (strpos($key,'ADDTOKART') !== false) {
				session_unregister($key);
			}
		}
	}
}

function krt_getAddToKartLink($baseRef,$fields) 
{
	$linkTm = $baseRef . '?';
	foreach($fields as $key=>$value) {
		$linkTm .= $key . '=' . htmlentities($value) . '&';
	}
	
	return $linkTm;
}

function krt_adodb2mysql($rs,$conn,$db) {
		$row = $rs->GetRowAssoc(false);
		
		require_once(dirname(__FILE__).'/../common/lib/db/KT_Db.php');
		if (is_resource($conn)) {
			$conn_conn = new KT_Connection($conn, $db);
		} else {
			$conn_conn = &$conn;
		}
		
		$localFakeArr = array();
		$i = 0;
		while (!$rs->EOF) {
			foreach($row as $key=>$value) {
				if (!isset($localFakeArr[$key])) {
					$localFakeArr[$key] = array();
				}
				$localFakeArr[$key][$i] = $rs->Fields($key);
			}
			$i++;
			$rs->MoveNext();
		}
		
		$fakeRS = new KT_FakeRecordset($conn_conn);
		$ret = $fakeRS->getFakeRecordset($localFakeArr);
		return $ret;
}

/**
	inserts a value into a session variable
	@params
		$value - value to be inserted into session variable
		$sessionVarName - name of the session variable
		$add - if true make the session variable an array to store multiple values
	@return
		none
*/
function krt_insertIntoSession($value,$sessionVarName,$add = false) {
	if (isset($value) && !empty($value)) {
		if (isset($_SESSION[$sessionVarName]) && $add) {
			$tmp = $_SESSION[$sessionVarName];
			if (is_array($tmp)) {
				array_push($tmp,$value);
				if (count($tmp) > 10) {
					array_shift($tmp);
				}
				$_SESSION[$sessionVarName] = $tmp;
			} else {
				$_SESSION[$sessionVarName] = array($tmp,$value);
			}
		} else {
			$_SESSION[$sessionVarName] = $value;
		}
	}
}

/**
	caches the currencies in a global array (KT_currencies)	
	@params
		none
	@return
		none
*/
function krt_cacheCurrencies() {
	if (isset($GLOBALS['KT_currencies'])) {
		$KT_currencies = $GLOBALS['KT_currencies'];
	}
	
	if (!isset($KT_currencies)) {
		$kartProps = $GLOBALS['kartProps'];
		$connName = $kartProps['Korders']['connection'];
		//TODO
		// de dehardcodat currency table -> kartprops;
		$sql = "select * from currency_cur order by default_cur desc, name_cur";
		if (isset($GLOBALS[$connName])){
		  $conn_kart = $GLOBALS[$connName];
		  if (is_resource($conn_kart)) {
				$connTmp = new KT_Connection($conn_kart, $GLOBALS['database_' . $connName]);
		  } else {
				$connTmp = $conn_kart;
		  }
		  
		  $rs = $connTmp->Execute($sql) or die('<b>Cannot connect to the currency table! '.mysql_error().'</b>');
		} else {
		   die ('Kart connection is not defined in $kartProps[\'Korders\'][\'connection\']');
		}
		$KT_currencies = array();
		$sw = true;
		while (!$rs->EOF) {
			if ($sw) {
				$KT_currencies['default'] = $rs->Fields('name_cur');
				$sw = false;
			}
			$KT_currencies[$rs->Fields('name_cur')] = array();
			$KT_currencies[$rs->Fields('name_cur')]['prefix']=$rs->Fields('prefix_cur');
			$KT_currencies[$rs->Fields('name_cur')]['postfix']=$rs->Fields('postfix_cur');
			$KT_currencies[$rs->Fields('name_cur')]['decimals']=$rs->Fields('decimals_cur');
			$KT_currencies[$rs->Fields('name_cur')]['thsep']=$rs->Fields('thsep_cur');
			$KT_currencies[$rs->Fields('name_cur')]['decsep']=$rs->Fields('decsep_cur');
			$KT_currencies[$rs->Fields('name_cur')]['exchangerate']=$rs->Fields('exchangerate_cur');
			$rs->MoveNext();
		}
		$GLOBALS['KT_currencies'] = $KT_currencies;
	}
}

/**
	gets the default currency:
	- checks the cookies and validates it in the KT_currencies array
	- or gets the default one from the gloval KT_currencies array
	@params
		none
	@return
		string - the current currency ('USD')
*/
function krt_getCurrentCurrency() {
	krt_cacheCurrencies();
	if (isset($GLOBALS['KT_currencies'])) {
		$KT_currencies = $GLOBALS['KT_currencies'];
	}
	$currency = '';
	
	if (isset($_COOKIE['currency'])) {
		if (!isset($KT_currencies[$_COOKIE['currency']])) {
			if (isset($KT_currencies['default'])) {
				$currency = $KT_currencies['default'];
			}
		} else {
			$currency = $_COOKIE['currency'];
		}
	} else {
		if (isset($KT_currencies['default'])) {
			$currency = $KT_currencies['default'];
		}
	}

	return $currency;
}

/**
	transforms a price from the default currency to the specified one	
	@params
		$price - float - the price to be transformed (1234.52)
		$currency - string - the currency to use while transforming ('EUR')
	@return
		float - the transformed price (1001.12)
*/
function krt_transformPrice($price, $currency) {
	krt_cacheCurrencies();
	$KT_currencies = $GLOBALS['KT_currencies'];
	if (@$KT_currencies[$currency]['exchangerate']>0) {
		return $price / $KT_currencies[$currency]['exchangerate'];
	} else {
		return $price;
	}
}

/**
	formats the price to the sepcified currency (adds prefix, suffix and so on)	
	@params
		$price - float - the price to be transformed (1234.52)
		$currency - string - the currency to use while transforming ('USD')
	@return
		string - the formatted price ('$1,234.52')
*/
function krt_formatPrice($price, $currency) {
	krt_cacheCurrencies();
	$KT_currencies = $GLOBALS['KT_currencies'];
	$ret  = $KT_currencies[$currency]['prefix'];
	$ret .= number_format($price, $KT_currencies[$currency]['decimals'], $KT_currencies[$currency]['decsep'], $KT_currencies[$currency]['thsep']);
	$ret .= $KT_currencies[$currency]['postfix'];
	return $ret;
}

/**
	displayes the formated and translated price in the current currency	
	@params
		$price - float - the price to be transformed (1234.52)
	@return
		string - the formatted and transformed price ('35.000.000 ROL')
*/
function krt_showPrice($price) {
	$currency = krt_getCurrentCurrency();
	if ($currency == '') {
		return $price;
	}
	$newPrice = krt_transformPrice($price, $currency);
	$newPrice = krt_formatPrice($newPrice, $currency);
	return $newPrice;
}

function krt_getCheckoutObject($relPath) 
{
	$kartProps = $GLOBALS['kartProps']; 
	$checkOut_class = "krt_Checkout" . ucfirst($kartProps['payment']['type']);
	require_once(dirname(__FILE__).'/'.$checkOut_class . ".class.php");
	$checkOut_class_name = "krt_checkout" . ucfirst($kartProps['payment']['type']);
	return new $checkOut_class_name($relPath, $kartProps['payment']['properties']);
}

	
	
function krt_saveKartToDB(&$tNG, $userId) 
{
	$kartProps = $GLOBALS['kartProps']; 
	// save kart to database
	$KartFV_RS = &krt_getKartRecordset();
	if ($userId > 0) {
		$userId = "'$userId'";
	} else {
		$userId = "null";
	}
	
	$sql = "SELECT COUNT(*) AS cnt FROM ".$kartProps['Korders']['orders']['tableName']." WHERE ".$kartProps['Korders']['orders']['pk']."='".$KartFV_RS->getOrderID()."'";
	$rs = $tNG->connection->Execute($sql);
	if (!$rs) {
		return new tNG_error("<br>" . $sql, array(), array());
	}
	
	$sql = array();
	$sql[0] = "DELETE FROM ".$kartProps['Korders']['orderDetails']['tableName']." WHERE ".$kartProps['Korders']['orderDetails']['orderId']."='" . $KartFV_RS->getOrderID() . "';";
	if ($rs->Fields('cnt') == 0) {
		$sql[1] = "INSERT INTO ".$kartProps['Korders']['orders']['tableName']." (".$kartProps['Korders']['orders']['pk'].", ".$kartProps['Korders']['orders']['date'].", ".$kartProps['Korders']['orders']['amount'].", ".$kartProps['Korders']['orders']['userid'].", taxes_ord, shipping_ord, currency_ord) VALUES ('" . $KartFV_RS->getOrderID() . "', NOW(), ".($KartFV_RS->getTotalPayable()).", $userId, ".($KartFV_RS->getTotalTaxes()).", ".($KartFV_RS->getShippingCost()).", '".krt_getCurrentCurrency()."')";
	} else {
		$sql[1] = "UPDATE ".$kartProps['Korders']['orders']['tableName']." set ".$kartProps['Korders']['orders']['amount']."=".($KartFV_RS->getTotalPayable())." , ".$kartProps['Korders']['orders']['userid']."=$userId, taxes_ord=".($KartFV_RS->getTotalTaxes()).", shipping_ord=".($KartFV_RS->getShippingCost()).", currency_ord='".krt_getCurrentCurrency()."' where ".$kartProps['Korders']['orders']['pk']."='".$KartFV_RS->getOrderID()."'";
	}
	if (!function_exists('KT_escapeForSql')){
			require_once(dirname(__FILE__).'/../common/KT_functions.inc.php');	
	}
	$max_fields = sizeof($KartFV_RS->fields);
	for ($i=0, $n=sizeof($sql); $i < $max_fields; $i++, $n++) {
		$fields = $kartProps['Korders']['orderDetails']['orderId'];
		$values = "'" . $KartFV_RS->getOrderID() . "'";

		$fields .= ", " . $kartProps['Korders']['orderDetails']['productId'];
		$values .= ", " . KT_escapeForSql($KartFV_RS->fields[$i]['id'], 'STRING_TYPE');

		$fields .= ", " . $kartProps['Korders']['orderDetails']['quantity'];
		$values .= ", " . KT_escapeForSql($KartFV_RS->fields[$i]['quantity'], 'STRING_TYPE');

		$fields .= ", " . $kartProps['Korders']['orderDetails']['name'];
		$values .= ", " . KT_escapeForSql($KartFV_RS->fields[$i]['name'], 'STRING_TYPE');

		$fields .= ", " . $kartProps['Korders']['orderDetails']['productproperties'];
		$values .= ", " . KT_escapeForSql($KartFV_RS->fields[$i]['properties'], 'STRING_TYPE');

		$fields .= ", " . $kartProps['Korders']['orderDetails']['price'];
		$values .= ", " . KT_escapeForSql($KartFV_RS->fields[$i]['price'], 'STRING_TYPE');

		$sql[$n] = "INSERT INTO ".$kartProps['Korders']['orderDetails']['tableName']." (" . $fields . ") VALUES (" . $values . ");";
	}
	$max_sql = sizeof($sql);
	for ($i=0; $i < $max_sql; $i++) {
		if (!$tNG->connection->Execute($sql[$i])) {
			return new tNG_error($tNG->connection->ErrorMsg() . "<br>" . $sql[$i], array(), array());
		}
	}
	return '';
}
?>
